#include <MozziGuts.h>
#include <Oscil.h> // oscillator 
#include <tables/cos2048_int8.h> // table for Oscils to play
#include <AutoMap.h> // maps unpredictable inputs to a range
 #define CONTROL_RATE 64 // powers of 2 please
// desired carrier frequency max and min, for AutoMap
const int MIN_CARRIER_FREQ = 1220;
const int MAX_CARRIER_FREQ = 50;

// desired intensity max and min, for AutoMap, note they're inverted for reverse dynamics
const int MIN_INTENSITY = 700;
const int MAX_INTENSITY = 10;
int triggerLatch = 0;
AutoMap kMapCarrierFreq(0,1023,MAX_CARRIER_FREQ,MIN_CARRIER_FREQ);
AutoMap kMapCarrierFreq2(0,1023,MAX_CARRIER_FREQ,MIN_CARRIER_FREQ);

AutoMap kMapIntensity(0,1023,MIN_INTENSITY,MAX_INTENSITY);
float carrier_freq = 333; //oscillator frequency
float carrier_freq2 = 333; //frequency after octave button
int pitch_value2; //for the bass notes



Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aCarrier(COS2048_DATA);
Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aModulator(COS2048_DATA);


long fm_intensity; // carries control info from updateControl() to updateAudio()



//////////////////
int ratio_PIN = A0; 
int mod_ratio = mozziAnalogRead(ratio_PIN); // harmonics
//int mod_ratio = 3;
int Soundpin = 9;
const int pitch_PIN = A3; // set the input for the knob to analog pin 0
const int mod_PIN = A2; // set the input for the LDR to analog pin 1
const int oct_PIN = A1; //A3 oct pitch  
    // read the knobS
int pitch_value = mozziAnalogRead(pitch_PIN); // value is 0-1023
   //READ THE MOD LEVEL
int mod_level= mozziAnalogRead(mod_PIN);

float gamArray[8]{204.40, 408.81, 433.51, 597.81, 648.19, 820.33,872.61,1198.57};
float gamTone = 0; 


//BUTTONS NEXT WHEN NEEDED
//int testD4 = digitalRead(4); 
char killswitchD4 = LOW;//INPUT FROM SEQUENCER)
char octaveD7 = digitalRead(7);//OCTAVE SWITCHING
char testD11 = digitalRead(11); //SWITCH D11
char gammaSwitchD12 = digitalRead(12);//CHANGE PITCH TO GAMELAN PITCHES
int volumeCont= 0; //volume control



void setup() {
  Serial.begin(115200); // set up the Serial output so we can look at the piezo values // set up the Serial output for debugging
  startMozzi(); // :))
}




//////////////////////////////////////////////








void updateControl(){

  //INPUT FROM THE SEQUENCER
killswitchD4 = digitalRead(4); 
pitch_value = mozziAnalogRead(pitch_PIN);
pitch_value2 = mozziAnalogRead(oct_PIN);
pitch_value = kMapCarrierFreq(pitch_value) ;
pitch_value2 = kMapCarrierFreq2(pitch_value2);


//trigger from sequencer

   // read the knob
int randlower = random(1,3);

if(randlower == 3){
carrier_freq = (pitch_value - pitch_value2);
}else{
carrier_freq = (pitch_value - pitch_value2) / randlower;
  }

  

  if(gammaSwitchD12 == HIGH){
    //pitch_value = mozziAnalogRead(pitch_PIN); // value is 0-1023
 // map the knob to carrier frequency
carrier_freq = kMapCarrierFreq(pitch_value);}


//mod_ratio = mozziAnalogRead(ratio_PIN);
//float mod_ratio2 = map(mod_ratio,1200, 0, 1, 9);//gamescale sellector

  //calculate the modulation frequency to stay in ratio
float mod_freq = carrier_freq * mod_ratio;



  




   
  aModulator.setFreq(mod_freq);
  
  // read the light dependent resistor on the Analog input pin
mod_level= mozziAnalogRead(mod_PIN); // value is 0-1023
  
  // print the value to the Serial monitor for debugging
  
 // Serial.print("carrier_freq2  = "); 
  //Serial.print(carrier_freq2 ); 
 // Serial.print("\t"); // prints a tab
  
  
//Serial.print("octaveD7 = "); 
//Serial.print(octaveD7); 
//  Serial.print("\t"); // prints a tab
  
  fm_intensity = kMapIntensity(mod_level);


testD11 = digitalRead(11);
  if(testD11 == LOW) {
int randlower2 = random(1,200);
 fm_intensity = fm_intensity + randlower2;
  carrier_freq2 = carrier_freq;
  aCarrier.setFreq((carrier_freq2)* volumeCont);
  }
    
  //FILTER SWITCH D7
  if(testD11 == HIGH) {
    // set the FM oscillator frequencies to the calculated values
    carrier_freq2 = carrier_freq;
  aCarrier.setFreq((carrier_freq2)* volumeCont);}





  triggerLatch = 1;
  volumeCont = 1;

  
 

  
  


}


int updateAudio(){
  long modulation = (fm_intensity * aModulator.next()); 
  return aCarrier.phMod(modulation)* volumeCont; // phMod does the FM

    
}






//////////////////////////////////
void loop() {

audioHook();

}


